/** PersonInheritanceDemo.java --- single inheritance in Java
 * @author Uwe Assmann
 * @date 2013-04-20
 */

import java.util.*;

/**
   Simple main program
 */
public class PersonInheritanceDemo {
    // Main program. 
    public static void main(String args[]) {
	// (1) Create the objects
	Professor UweAssmann = new Professor("Uwe Aßmann");
	// (a) What could be improved with Prof. Aßmann?

	Student VictoriaMiller = new Student("Victoria Miller");
	// (b) Make Student Victoria Miller a student of Prof. Aßmann

	// (2) Construct the object net
	VictoriaMiller.startStudy(UweAssmann);

	// (3) Do the real work
	VictoriaMiller.study();
    }
}

/** 
 * Base class Person.
 */

class Person {
    String name; // internal attribute name; not visible
    // Constuctor 
    public Person() { }
    public Person(String a_name) { setName(a_name); }
    // Attribute query: read the name of a Person
    String getName() { return name; }
    // Attribute modifier: change the name of a Person
    void setName(String a_name) { name = a_name; }
}

/**
   class Professor - what's wrong with it?
*/
class Professor extends Person {
    //   String name; 
    int numberOfStudents; 
    // Crowd of students
    Student students[];

    // Constructors
    public Professor(String a_name) { 
	name = a_name;
	numberOfStudents = 0; 
	// Create array of 200 students
	students = new Student[200];
    }
    String getName() { return name; }
    int getNumberOfStudents() { return numberOfStudents; }
    void setNumberOfStudents(int a_numberOfStudents) { numberOfStudents = a_numberOfStudents; }
    void incrNumberOfStudents() { numberOfStudents++; }
    void registerStudent(Student aStudent) { 
	if (numberOfStudents < 200) {
	    System.out.println("Welcome, dear student "+aStudent.getName()+" to my course ST!...\n");
	    students[numberOfStudents] = aStudent; 
	    incrNumberOfStudents();
	    System.out.println(getName()+": I have now "+getNumberOfStudents()+" students in my course ST...\n");
	} else {
	    System.out.println("Sorry, course is full...\n");
	}
    }
} 

class Student extends Person {
    protected int studyYear;
    public Student(String a_name) { 
	name = a_name;
    }  
    void startStudy(Professor prof) { 
	prof.registerStudent(this);
	System.out.println("Starting to study with Prof. "+prof.getName()+" in course ST...\n");
    }
    void study() { 
	System.out.println(getName()+" is working hard .... in course ST...\n");
	System.out.println("  Writing up questions...");
	System.out.println("  Asking questions...");
	System.out.println("  Working on a course map (Vorlesungskarte) ...");
	System.out.println("  Working on a course matrix (Vorlesungsmatrix) ...");
	System.out.println("Working hard .... in course ST...");
    }
}

class Beginner extends Student {
    public Beginner(String a_name) { 
	super(a_name); 
	studyYear = 1; 
    }
}

class LongtimeStudent extends Student {
    public LongtimeStudent(String a_name) { 
	super(a_name); 
	studyYear = 6; 
    }
}
